using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
 
namespace AdvancedBarUISynchronization
{
    /// <summary>
    /// Add-in Express for Internet Explorer Bar
    /// </summary>
    [ComVisible(true), Guid("073AD36E-812D-47EA-A6F0-B226683AFAB2")]
    public class CustomUIBar : AddinExpress.IE.ADXIEAdvancedBar
    {
        private bool lockUIUpdates = false;
        private TextBox textBox1;
        private bool allowSynchronization = true;
        private CheckBox checkBox1;

        private delegate void UpdateTextFunc(string text);

        public CustomUIBar()
        {
            InitializeComponent();
        }

        private TableLayoutPanel tableLayoutPanel1;
        private Button button1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
            this.button1 = new System.Windows.Forms.Button();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.checkBox1 = new System.Windows.Forms.CheckBox();
            this.tableLayoutPanel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // tableLayoutPanel1
            // 
            this.tableLayoutPanel1.ColumnCount = 1;
            this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
            this.tableLayoutPanel1.Controls.Add(this.button1, 0, 0);
            this.tableLayoutPanel1.Controls.Add(this.textBox1, 0, 2);
            this.tableLayoutPanel1.Controls.Add(this.checkBox1, 0, 1);
            this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
            this.tableLayoutPanel1.Name = "tableLayoutPanel1";
            this.tableLayoutPanel1.RowCount = 3;
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
            this.tableLayoutPanel1.Size = new System.Drawing.Size(190, 201);
            this.tableLayoutPanel1.TabIndex = 0;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(3, 3);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(160, 23);
            this.button1.TabIndex = 0;
            this.button1.Text = "Disable synchronization";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // textBox1
            // 
            this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.textBox1.Location = new System.Drawing.Point(3, 63);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(184, 135);
            this.textBox1.TabIndex = 2;
            this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
            // 
            // checkBox1
            // 
            this.checkBox1.AutoSize = true;
            this.checkBox1.Location = new System.Drawing.Point(3, 33);
            this.checkBox1.Name = "checkBox1";
            this.checkBox1.Size = new System.Drawing.Size(134, 17);
            this.checkBox1.TabIndex = 1;
            this.checkBox1.Text = "Asynchonous changes";
            this.checkBox1.UseVisualStyleBackColor = true;
            // 
            // CustomUIBar
            // 
            this.Controls.Add(this.tableLayoutPanel1);
            this.Name = "CustomUIBar";
            this.Size = new System.Drawing.Size(190, 201);
            this.OnSynchronize += new AddinExpress.IE.ADXIEBarSynchronize_EventHandler(this.CustomUIBar_OnSynchronize);
            this.Load += new System.EventHandler(this.CustomUIBar_Load);
            this.tableLayoutPanel1.ResumeLayout(false);
            this.tableLayoutPanel1.PerformLayout();
            this.ResumeLayout(false);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.Module.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.Module.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        private void UpdateState()
        {
            this.button1.Text = (this.allowSynchronization ? "Disable synchronization" : "Enable synchronization");
            this.BarItem.ApplyChangesForAllTabs = this.allowSynchronization;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.allowSynchronization = !this.allowSynchronization;
            UpdateState();
        }

        private void CustomUIBar_Load(object sender, EventArgs e)
        {
            UpdateState();
        }

        private void CustomUIBar_OnSynchronize(object sender, object context, object value)
        {
            if ((context != null) && context.Equals("textBox1") && this.Visible)
            {
                object[] data = (object[])value;

                if (data.Length == 3 && (int)data[0] != this.Module.ThreadID)
                {
                    if (!(bool)data[1])
                        this.Invoke(new UpdateTextFunc(UpdateText), (string)data[2]);
                    else
                        this.Module.SendMessage(IEModule.WM_TEXTCHANGED, Marshal.StringToCoTaskMemUni((string)data[2]), IntPtr.Zero);
                }
            }
        }

        internal void UpdateText(string text)
        {
            this.lockUIUpdates = true;
            this.textBox1.Text = text;
            this.lockUIUpdates = false;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (this.allowSynchronization && (!this.lockUIUpdates))
            {
                this.Synchronize("textBox1", new object[] { this.Module.ThreadID, this.checkBox1.Checked, this.textBox1.Text });
            }
        }
 
    }
}

