using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
 
namespace AdvancedBarUISynchronization
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("2909CE52-C542-44E7-AA20-35375AD545EC")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        internal const int WM_USER = 0x0400;
        internal const int WM_TEXTCHANGED = WM_USER + 10;

        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        private ADXIEAdvancedBarsManager adxieAdvancedBarsManager1;
        private ADXIEAdvancedBarItem adxieAdvancedBarItem1;
 
        public IEModule(IContainer container)
        {
            container.Add(this);
 
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(IEModule));
            this.adxieAdvancedBarsManager1 = new AddinExpress.IE.ADXIEAdvancedBarsManager(this.components);
            this.adxieAdvancedBarItem1 = new AddinExpress.IE.ADXIEAdvancedBarItem(this.components);
            // 
            // adxieAdvancedBarsManager1
            // 
            this.adxieAdvancedBarsManager1.ActiveBottomLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("adxieAdvancedBarsManager1.ActiveBottomLayout")));
            this.adxieAdvancedBarsManager1.ActiveLeftLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("adxieAdvancedBarsManager1.ActiveLeftLayout")));
            this.adxieAdvancedBarsManager1.ActiveRightLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("adxieAdvancedBarsManager1.ActiveRightLayout")));
            this.adxieAdvancedBarsManager1.ActiveTopLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("adxieAdvancedBarsManager1.ActiveTopLayout")));
            this.adxieAdvancedBarsManager1.Bars.Add(this.adxieAdvancedBarItem1);
            this.adxieAdvancedBarsManager1.BrowserState = AddinExpress.IE.tagREADYSTATE.READYSTATE_UNINITIALIZED;
            this.adxieAdvancedBarsManager1.IsKeyboardLayoutChanging = false;
            this.adxieAdvancedBarsManager1.KeyboardLocked = true;
            this.adxieAdvancedBarsManager1.SplitterModeActive = false;
            // 
            // adxieAdvancedBarItem1
            // 
            this.adxieAdvancedBarItem1.ApplyChangesForAllTabs = true;
            this.adxieAdvancedBarItem1.BarObj = null;
            this.adxieAdvancedBarItem1.BarType = "AdvancedBarUISynchronization.CustomUIBar";
            this.adxieAdvancedBarItem1.Id = "{295FD77A-DF86-4F9B-B285-E555E94E1D8C}";
            this.adxieAdvancedBarItem1.MenuText = "adxieAdvancedBarItem1";
            this.adxieAdvancedBarItem1.Visible = true;
            // 
            // IEModule
            // 
            this.HandleShortcuts = true;
            this.LoadInMainProcess = false;
            this.ModuleName = "Advanced Bar UI Synchronization";
            this.OnSendMessage += new AddinExpress.IE.ADXIESendMessage_EventHandler(this.IEModule_OnSendMessage);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }
 
        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }
 
        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        private void IEModule_OnSendMessage(ADXIESendMessageEventArgs e)
        {
            if (e.Message == WM_TEXTCHANGED)
            {
                if (this.adxieAdvancedBarItem1.BarObj != null)
                {
                    IntPtr lpText = e.WParam;

                    try
                    {
                        string text = Marshal.PtrToStringUni(lpText);
                        ((CustomUIBar)this.adxieAdvancedBarItem1.BarObj).UpdateText(text);
                    }
                    catch (Exception)
                    {
                    }
                    finally
                    {
                        if (lpText != IntPtr.Zero)
                            Marshal.ZeroFreeCoTaskMemUnicode(lpText);
                    }
                }
            }
        }

 
    }
}

